/*
 * Copyright (c) 2010 David Galindo <nowheremanmail@gmail.com>
 *
// TODO several files? or several wallets in database?
// TODO export to a file with pictures!!!??
// TODO import picture from camera
// TODO modify picture (zoom, ...)
 * TODO after change type it is not refreshed on list
 * TODO implements copy of information field (and images?)
 * TODO allow to change password
 * TODO use hilton notifications and banner???
 * TODO check types on import
 * TODO sort after insert new card
 * TODO add warn message when import and export!
 * TODO multilanguage
 * TODO groups implementation
 * TODO pc version?
 * TODO fix export and import to add field type
 */

#include "eWallet.h"
#include "Constants.h"
#include "DatabaseManager.h"
#include <Qt>
#include <QtGui>
#include <QFile>
#include <QDBusInterface>
#include <QDBusConnection>
#include <QDesktopServices>
#include <QListView>

//#ifdef Q_WS_MAEMO_5
//#include <mce/mode-names.h>
//#include <mce/dbus-names.h>
//#endif

DatabaseManager * dbManager;

eWallet::eWallet(QString group, eWallet * _parent, QWidget *parent) : QMainWindow(parent)
{
	types = _parent->types;
	fieldsByType = _parent->fieldsByType;

	centralWidget = NULL;
	currentGroup = group;

	this->setAttribute(Qt::WA_Maemo5AutoOrientation, true);
	//connect(QApplication::desktop(), SIGNAL(resized(int)), this, SLOT(orientationChanged(int)));

	this->setAttribute(Qt::WA_Maemo5StackedWindow);

	ascSort = true;
	currentFilter = "";

	isShowGroups = 2;

	showList ();
	showTargets(true, currentGroup);
}

eWallet::eWallet(QWidget *parent) : QMainWindow(parent)
{
	currentGroup = "";
	centralWidget = NULL;
	isShowGroups = 0;

	this->setAttribute(Qt::WA_Maemo5AutoOrientation, true);
	connect(QApplication::desktop(), SIGNAL(resized(int)), this, SLOT(orientationChanged(int)));

	this->setAttribute(Qt::WA_Maemo5StackedWindow);

	ascSort = true;
	currentFilter = "";

	loadTypesAndFields ();

	::dbManager = new DatabaseManager(this);

	askPassword ();

	QDBusConnection conn = QDBusConnection::systemBus(); //QString(MCE_SERVICE), QString(MCE_SIGNAL_PATH)
	bool success = conn.connect("","", QString("com.nokia.mce.signal"/*MCE_SIGNAL_IF*/), QString("display_status_ind"/*MCE_DISPLAY_SIG*/) , this, SLOT(listenInactivity(QString)));
	//bool success = conn.connect("","", QString(MCE_SIGNAL_IF), QString(MCE_DISPLAY_SIG) , this, SLOT(listenInactivity(QString)));
}

void eWallet::orientationChanged(int o) {
	if (isAskPassword) {
		loginDialogDlg->orientationChanged (o);
	}
}
void eWallet::showList () {
	qDebug () << "going to showList";

	isAskPassword = false;

	setProperty("FingerScrollable", false);
	centralWidget = new QWidget(this);
	//centralWidget->grabGesture(Qt::SwipeGesture);

//		grabGesture(Qt::PanGesture);
//		grabGesture(Qt::PinchGesture);
//	    grabGesture(Qt::SwipeGesture);


	//backButton = new QPushButton("<< Back", this);

	setContextMenuPolicy(Qt::DefaultContextMenu);
//	centralWidget->setContextMenuPolicy(Qt::DefaultContextMenu);

	vboxlayout = new QVBoxLayout;
	vboxlayout->setSpacing(0);
	vboxlayout->setMargin(0);
	// Custom list box
	//vboxlayout->addWidget(backButton);

	fnListWidget = new QListWidget(this);
	fnListWidget->setSortingEnabled(false);
	fnListWidget->setFocusPolicy(Qt::NoFocus);
	vboxlayout->addWidget(fnListWidget);

	//fnListWidget->grabGesture(Qt::SwipeGesture);

	QObject::connect(fnListWidget, SIGNAL(itemClicked(QListWidgetItem *)), this, SLOT(selectItem(QListWidgetItem *)));
	QObject::connect(fnListWidget, SIGNAL(itemDoubleClicked(QListWidgetItem *)), this, SLOT(selectDItem(QListWidgetItem *)));

	inputWidget = new QHBoxLayout;
	inputWidget->setContentsMargins(2, 2, 2, 0);
	vboxlayout->addLayout(inputWidget);

	cancelSearch = new QPushButton(QIcon(":/resources/icon_clear.png"), "", this);
	searchField = new QLineEdit ();
	hideSearch = new QPushButton(QIcon(":/resources/icon_hide.png"), "", this);

	inputWidget->addWidget(cancelSearch);
	inputWidget->addWidget(searchField);
	inputWidget->addWidget(hideSearch);

	//QObject::connect(backButton, SIGNAL(clicked()), this, SLOT(_clickBack()));
	//backButton->hide ();

	QObject::connect(cancelSearch, SIGNAL(clicked()), this, SLOT(_cancelSearch()));
	QObject::connect(hideSearch, SIGNAL(clicked()), this, SLOT(_hideSearch()));
	QObject::connect(searchField, SIGNAL(textChanged(const QString &)), this, SLOT(textChanged(const QString &)));

	cancelSearch->hide ();
	searchField->hide ();
	hideSearch->hide ();

	centralWidget->setLayout(vboxlayout);

	createMenu ();

	qDebug () << "setCentralWidget(centralWidget);";
	setCentralWidget(centralWidget);

	qDebug () << "setFocus()";
	centralWidget->setFocus ();
}

void eWallet::_clickBack () {
	isShowGroups = (isShowGroups) % 2 + 1;
	_cancelSearch ();
	showInfo(true);
}
void eWallet::changeMode () {
	isShowGroups = (isShowGroups) % 2 + 1;
	_cancelSearch ();
	showInfo(true);
}

////void eWallet::swipeTriggered(QSwipeGesture *gesture) {
////	if (gesture->state() == Qt::GestureFinished) {
////		if (gesture->horizontalDirection() == QSwipeGesture::Left
////			|| gesture->verticalDirection() == QSwipeGesture::Up)
////			isShowGroups = (isShowGroups + 1) % 2 + 1;
////		else
////			isShowGroups = (isShowGroups + 1) % 2 + 1;
////		showInfo(false);
////	}
////}
//
//bool eWallet::gestureEvent(QGestureEvent *event) {
//    if (QGesture *swipe = event->gesture(Qt::SwipeGesture))
//    	changeMode();
//
////        swipeTriggered(static_cast<QSwipeGesture *>(swipe));
////    else if (QGesture *pan = event->gesture(Qt::PanGesture))
////        panTriggered(static_cast<QPanGesture *>(pan));
////    if (QGesture *pinch = event->gesture(Qt::PinchGesture))
////        pinchTriggered(static_cast<QPinchGesture *>(pinch));
//    return true;
//}
//
//
//bool eWallet::event(QEvent *event)
//{
////	qDebug () << "EVENT " << event->type();
//    if (event->type() == QEvent::Gesture) {
//    	qDebug () << "GESTURE";
//
//    	if (!isAskPassword) {
//    		return gestureEvent(static_cast<QGestureEvent*>(event));
//    	}
//    }
//    return QWidget::event(event);
//}

void eWallet::selectItem(QListWidgetItem * item) {
	if (isShowGroups == 1) {
		if (fnListWidget->currentItem() != item) {
			fnListWidget->setCurrentItem(item);
		}

		QString target = grouplist.at(fnListWidget->currentRow());
		//isShowGroups = 2;
		//backButton->show();
		if (extraWindow.isNull()) {
			extraWindow = new eWallet(target, this, this);
			//extraWindow->setAttribute(Qt::WA_Maemo5StackedWindow);
			extraWindow->setAttribute(Qt::WA_DeleteOnClose);
	        connect(extraWindow, SIGNAL(destroyed(QObject*)),
	                this, SLOT(extrawindowDestroyed(QObject*)));
	        extraWindow->show();
		}
		//showTargets(reset, target);
	}
	else {
		if (fnListWidget->currentItem() != item) {
			fnListWidget->setCurrentItem(item);
		}
		Target * target = list.at(fnListWidget->currentRow());
		viewTarget(target);
	}
}

void eWallet::selectDItem(QListWidgetItem * item) {
		selectItem(item);
}

void eWallet::listenInactivity(QString s) {
	//qDebug () << "HELLO " << s;
	if (s == QString("off") && ::dbManager->isReady ()) {
		::dbManager->lock ();

		// TODO sure????
		fnListWidget->clear();
		list.clear ();
		grouplist.clear ();

		if (!detailWindow.isNull()) {
			detailWindow->close();
			delete detailWindow;
			detailWindow = 0;
	    }

	    if (!detailWindowEdit.isNull()) {
			detailWindowEdit->close();
			delete detailWindowEdit;
			detailWindowEdit = 0;
	    }

	    if (!extraWindow.isNull()) {
	    	extraWindow->close();
			delete extraWindow;
			extraWindow = 0;
	    }

	}
	else {
		if (s == QString("on") && !::dbManager->isReady ()) {
			askPassword ();
		}
	}
}

void eWallet::textChanged (const QString & text) {
	currentFilter = text;
	filterBy (text);
}

void eWallet::filterBy (const QString & s) {
	if (isShowGroups == 1) {
		for (int i = 0; i < grouplist.size (); i++) {
			QString target = grouplist.at(i);

			if (s.length() == 0) {
				fnListWidget->item(i)->setHidden(false);
			}
			else {
				if (target.contains(s, Qt::CaseInsensitive)) {
					fnListWidget->item(i)->setHidden(false);
				}
				else {
					fnListWidget->item(i)->setHidden(true);
				}
			}
		}
	}
	else {
		for (int i = 0; i < list.size (); i++) {
			Target * target = list.at(i);

			if (s.length() == 0) {
				fnListWidget->item(i)->setHidden(false);
			}
			else {
				if (target->name.contains(s, Qt::CaseInsensitive)) {
					fnListWidget->item(i)->setHidden(false);
				}
				else {
					fnListWidget->item(i)->setHidden(true);
				}
			}
		}
	}
}

void eWallet::_cancelSearch () {
	currentFilter = "";
	searchField->setText("");
	searchField->hide();
	cancelSearch->hide();
	hideSearch->hide ();
}

void eWallet::_hideSearch () {
	searchField->hide();
	cancelSearch->hide();
	hideSearch->hide ();
}

void eWallet::lockWallet () {
	::dbManager->lock ();
	askPassword ();
}

void eWallet::deleteDB () {
	if (messageBox.isNull()) {
		messageBox = new QMessageBox(this);
		int b = messageBox->information(this, "Wallet", "Are you sure you want to remove all your data? You will lost all your data", QMessageBox::Yes, QMessageBox::No);
		if (b == QMessageBox::Yes) {
			::dbManager->reset ();

			if (!loginDialogDlg.isNull()) {
				loginDialogDlg->resetF ();
			}
		}
	}
	delete messageBox;
	messageBox = 0;
}

bool eWallet::openDataBase (QString pas)
{
	bool res = ::dbManager->openDB(pas);

	if (!res) {
		if (++times > 3) {
			exit(3);
		}
		else {
			if (!::dbManager->isReady ()) {
				if (messageBox.isNull()) {
					messageBox = new QMessageBox(this);
					messageBox->information(this, "Wallet", "Wrong password", QMessageBox::Ok);
				}
				delete messageBox;
				messageBox = 0;
			}
		}
	}
	else {
		showList ();

		if (isShowGroups == 0) {
			grouplist.clear ();
			grouplist = ::dbManager->getGroups ();

			if (grouplist.size() > 1)
				isShowGroups = 1;
			else
				isShowGroups = 2;
		}

		showInfo (true);
	}
	return res;
}

eWallet::~eWallet ()
{
	//delete ::dbManager;
}
/*
 * TYPES
 * 	S -> String
 * 	T -> Text
 * 	D -> Date
 *  U -> URL
 *  P -> Password
 *  N -> Number
 *  H -> Phone number
 */
void eWallet::loadTypesAndFields () {
	  QFile file(":/resources/types.txt");
	  QString line;

	  types = new QList<QString>;
	  fieldsByType = new QList<QList<TargetField>*>;

	  if ( file.open(QIODevice::Text | QIODevice::ReadOnly) ) {
	    // file opened successfully
	    QTextStream t(&file);        // use a text stream
	    // until end of file...
	    int i = 0;
	    while ( !t.atEnd() ) {
	      // read and parse the command line
	      QString line = t.readLine();         // line of text excluding '\n'
	      // do something with the line

	      if (line.length() > 0) {
	    	  if ((i++) == 0) {
	    		  int p = line.indexOf(';');
	    		  if (p >= 0) {
	    			  // TODO
	    			  QChar imageType = line.at(p + 1);
					  this->types->append(line.mid(0, p).trimmed());
	    		  }
	    		  else {
					  this->types->append(line);
	    		  }
	    		  this->fieldsByType->append (new QList<TargetField>);
				  //qDebug () << " new type "<< line << " " << this->types.length();
	    	  }
	    	  else {
	    		  int p = line.indexOf(';');
	    		  if (p >= 0) {
	    			  int type = TYPE_STRING;
	    			  switch (line.at(p + 1).toAscii()) {
						  case 'T':
							  type = TYPE_TEXT;
							  break;
						  case 'D':
							  type = TYPE_DATE;
							  break;
						  case 'U':
							  type = TYPE_URL;
							  break;
						  case 'P':
							  type = TYPE_PASSWORD;
							  break;
						  case 'N':
							  type = TYPE_INTEGER;
							  break;
						  case 'H':
							  type = TYPE_PHONE_NUMBER;
							  break;
						  case 'S':
						  default:
			    			  type = TYPE_STRING;
						}
	    			  this->fieldsByType->at(this->types->length() - 1)->append(TargetField (line.mid(0, p).trimmed(), type, true, i));
	    		  }
	    		  else {
	    			  this->fieldsByType->at(this->types->length() - 1)->append(TargetField (line, TYPE_STRING, true, i));
	    		  }
				  //qDebug () << " new field "<< line << " " << this->types.length();
	    	  }
	      }
	      else {
	    	  i = 0;
	      }

	    }

	    // Close the file
	    file.close();
	  }
}

void eWallet::keyPressEvent(QKeyEvent* event) {
	//qDebug()<<"key pressed " << event->key();
	
	if (!isAskPassword) {
		if (searchField->isHidden()) {
//			if (event->key () == Qt::Key_Left || event->key () == Qt::Key_Right ) {
//				changeMode();
//				event->accept();
//			}
//			else {
				cancelSearch->show ();
				searchField->show ();
				hideSearch->show ();
				searchField->setFocus();

				QCoreApplication::sendEvent (searchField, event);
				event->accept();
//			}
		}
		else {
				QWidget::keyPressEvent(event);//event->accept();
		}
	}
	else {
		QWidget::keyPressEvent(event);//event->accept();
	}
	//timer->stop();
	//timer->start(5000);
}

bool sortTargetsASC (const Target * f, const Target * g) {
	return f->name.toLower() < g->name.toLower();
}
bool sortTargetsDES (const Target * f, const Target * g) {
	return f->name.toLower() > g->name.toLower();
}
bool sortStringASC (const QString f, const QString g) {
	return f.toLower() < g.toLower();
}
bool sortStringDES (const QString f, const QString g) {
	return f.toLower() > g.toLower();
}

QPixmap eWallet::getImage (Target * target) {
	QPixmap image;
	if (target->getPictureSmall() != NULL) {
		image = QPixmap::fromImage (*target->getPictureSmall());

		// at this moment we don't need anymore original images!
		target->freeResources();
	} else {
		QString tmp = ":/resources/empty_";
		tmp += target->type.simplified().replace(' ', '_');
		tmp += ".png";

		if (QResource (tmp).isValid()) {
			image = QPixmap (tmp);
		}
		else {
			image = QPixmap (":/resources/empty_Others.png");
		}
	}
	return image;
}

void eWallet::showGroups(bool reset)
{
	qDebug () << "show Groups " << reset;

	// Clean previous items from the layout
	fnListWidget->clear();

	if (reset) {
		grouplist.clear ();
		grouplist = ::dbManager->getGroups ();
	}

	if (ascSort)
		qSort (grouplist.begin(),grouplist.end(),sortStringASC);
	else
		qSort (grouplist.begin(),grouplist.end(),sortStringDES);

	//fnListWidget->setIconSize (QSize (SMALL_WIDTH, SMALL_HEIGH));
	//fnListWidget->setContentsMargins(10, 1, 0, 1);

	for (int i = 0; i < grouplist.size (); i++) {
		QString target = grouplist.at(i);

		QListWidgetItem* listitem = new QListWidgetItem(target, fnListWidget);
		//listitem->set(target->getSummary());
		fnListWidget->addItem(listitem);
	}

	//filterBy(currentFilter);

	fnListWidget->setCurrentRow(0);

	update();
}

void eWallet::showInfo(bool reset) {
	if (isShowGroups == 1) {
		//backButton->hide();
		showGroups(reset);
	}
	else {
		showTargets(reset, currentGroup);
	}
}

void eWallet::showTargets(bool reset, const QString & filter)
{
	qDebug () << "show Targets " << reset;

	// Clean previous items from the layout
	fnListWidget->clear();

	if (reset) {
		list.clear ();
		list = ::dbManager->getTargets (filter);
	}

	if (ascSort)
		qSort (list.begin(),list.end(),sortTargetsASC);
	else
		qSort (list.begin(),list.end(),sortTargetsDES);

	fnListWidget->setIconSize (QSize (SMALL_WIDTH, SMALL_HEIGH));
	//fnListWidget->setContentsMargins(10, 1, 0, 1);

	for (int i = 0; i < list.size (); i++) {
		Target * target = list.at(i);

		QListWidgetItem* listitem = new QListWidgetItem(getImage(target), target->name, fnListWidget);
		//listitem->set(target->getSummary());
		fnListWidget->addItem(listitem);
		
	}

	filterBy(currentFilter);

	fnListWidget->setCurrentRow(0);

	update();
}

void eWallet::createMenu()
{
	qDebug () << "create Menu " << isAskPassword;

	if (isAskPassword) {
		menuBar()->clear();

		menuBar()->addAction("About", this, SLOT(about()));
		menuBar()->addAction("Delete DB", this, SLOT(deleteDB()));
		menuBar()->addAction("Exit", QApplication::instance(), SLOT(quit()));
	}
	else {
		menuBar()->clear();

		menuBar()->addAction("New", this, SLOT(newTarget()));
		menuBar()->addAction("Edit", this, SLOT(_editcTarget()));
		menuBar()->addAction("Invert Sort", this, SLOT(sort()));
		menuBar()->addAction("Import", this, SLOT(import()));
		menuBar()->addAction("Export", this, SLOT(exportData()));
		//menuBar()->addAction("Change View", this, SLOT(changeMode()));
		menuBar()->addAction("Exit", QApplication::instance(), SLOT(quit()));
	}
}

void eWallet::sort()
{
	ascSort = !ascSort;
	showInfo(false);
}

bool eWallet::__insertTarget(Target* target)
{
	if (::dbManager->insertTarget(target)) {
		//qDebug () << "Adding new item";
		::dbManager->updateFields (target);
		
		target->freeFieldList();
		return true;
	}
	return false;
}

bool eWallet::_insertTarget(Target* target)
{
	if (__insertTarget(target)) {
		if (isShowGroups == 2) {
			list.append(target);

	//		if (ascSort)
	//			qSort (list.begin(),list.end(),sortTargetsASC);
	//		else
	//			qSort (list.begin(),list.end(),sortTargetsDES);

			QListWidgetItem* listitem = new QListWidgetItem(getImage(target), target->name, fnListWidget);

			int pos = list.indexOf(target);
			qDebug () << "position of new " << pos << " OF " << list.size ();

			if (pos < list.size()) {
				//qDebug () << "insert position of new " << pos << " OF " << list.size ();
				fnListWidget->insertItem(pos, listitem);
			}
			else {
				//qDebug () << "append position of new " << pos << " OF " << list.size ();
				fnListWidget->addItem(listitem);
			}
			fnListWidget->setCurrentItem(listitem);
		}
		else {
			showGroups(true);
		}
		return true;
	}
	return false;
}
bool eWallet::_deleteTarget(Target* target)
{
	if (messageBox.isNull()) {
		messageBox = new QMessageBox(this);
		int b = messageBox->information(this, "Wallet", "Are you sure you want to remove it?", QMessageBox::Yes, QMessageBox::No);
		if (b != QMessageBox::Yes) {
			delete messageBox;
			messageBox = 0;

			return false;
		}
	}
	delete messageBox;
	messageBox = 0;

	if (::dbManager->deleteTarget(target)) {
		if (isShowGroups == 2) {
			int i = list.indexOf(target);
			qDebug () << "DELETE ON " << i;
			qDebug () << "trying to remove " << i;
			list.removeAt(i);

			qDebug () << "trying to takeItem " << i;
			fnListWidget->takeItem(i); //oveItem (row);
			qDebug () << "delete " << i;
		}
//		target->freeFieldList();
//		target->freeResources();
//		delete target;
		delete target;
		return true;
	}
	return false;
}
bool eWallet::_updateTarget(Target* target)
{
	//qDebug () << "UPDATE ON " << i;

	if (::dbManager->updateTarget(target)) {
		::dbManager->updateFields (target);
		
		target->freeFieldList();

		if (isShowGroups == 2) {
			int i = list.indexOf(target);
			QListWidgetItem* listitem = fnListWidget->item (i);
			listitem->setText(target->name);
		}
		else {
			showGroups(true);
		}
		return true;
	}
	return false;
}

bool eWallet::_updateTargetPicture(Target* target)
{
	//qDebug () << "UPDATE ON " << i;
	if (::dbManager->updateTargetPicture(target)) {
		if (isShowGroups == 2) {
			int i = list.indexOf(target);
			QListWidgetItem* listitem = fnListWidget->item (i);
			listitem->setIcon(getImage(target));
		}
		return true;
	}
	return false;
}
bool eWallet::_updateTargetPictureBack(Target* target)
{
	if (::dbManager->updateTargetPictureBack(target)) {
		return true;
	}
	return false;
}

void eWallet::deleteTarget(Target * target) {
	if (_deleteTarget (target)) {
		//delete target;
	}
}

void eWallet::extrawindowDestroyed(QObject* obj) {
    disconnect(obj, SIGNAL(destroyed(QObject*)),
               this, SLOT(windowDestroyed(QObject*)));

	delete extraWindow;
	extraWindow = 0;

	qDebug () << "WINDOW DESTROYED YES";

	showGroups (true);
}

void eWallet::windowDestroyed(QObject* obj)
{
    disconnect(obj, SIGNAL(destroyed(QObject*)),
               this, SLOT(windowDestroyed(QObject*)));

    if (obj == detailWindow.data()) {
		delete detailWindow;
		detailWindow = 0;
    }
    else
    if (obj == detailWindowEdit.data()) {
		delete detailWindowEdit;
		detailWindowEdit = 0;
    }
}

void eWallet::viewTarget(Target * rent) {

	dbManager->getFields(rent);

	if (detailWindow.isNull()) {
		detailWindow = new DetailWindow(rent, "", false, false, this, this);

		connect(detailWindow, SIGNAL(editTarget(Target*)),
                      this, SLOT(editTarget(Target*)));
		connect(detailWindow, SIGNAL(newTarget()),
                      this, SLOT(newTarget()));
        detailWindow->setAttribute(Qt::WA_DeleteOnClose);
        connect(detailWindow, SIGNAL(destroyed(QObject*)),
                this, SLOT(windowDestroyed(QObject*)));
		//detailWindow->setAttribute(Qt::WA_Maemo5StackedWindow);
	    detailWindow->show(); //owMaximized();
	}
}

void eWallet::editTarget(Target * rent) {
	//qDebug()<<"edit ";

	dbManager->getFields(rent);

	if (detailWindowEdit.isNull()) {
		detailWindowEdit = new DetailWindow(rent, "", false, true, this, this);
		//detailWindowEdit->setAttribute(Qt::WA_Maemo5StackedWindow);
        detailWindowEdit->setAttribute(Qt::WA_DeleteOnClose);
        connect(detailWindowEdit, SIGNAL(destroyed(QObject*)),
                this, SLOT(windowDestroyed(QObject*)));
        detailWindowEdit->show();
	}
}

void eWallet::import() {
	QString path(QDesktopServices::storageLocation(QDesktopServices::HomeLocation));
	QString s = QFileDialog::getOpenFileName(
	                this,
	                "Choose import file",
	                path,
	                "Text (*.txt)");

	this->setAttribute(Qt::WA_Maemo5ShowProgressIndicator, true);

	if (!s.isNull () && !s.isEmpty ()) {

		  QFile file(s);
		  QString line;

		  Target * target = NULL;
		  if ( file.open(QIODevice::Text | QIODevice::ReadOnly) ) {
		    // file opened successfully
		    QTextStream t(&file);        // use a text stream
		    // until end of file...
		    int i = 0;
		    while ( !t.atEnd() ) {
		      // read and parse the command line
		      QString line = t.readLine();         // line of text excluding '\n'
		      // do something with the line

		      if (line.length() > 0) {
		    	  if (target == NULL) {
		    		  target = new Target ();
		    	  }

		    	  int j = line.indexOf(QChar(':'));
		    	  if (j > 0) {
					  switch (i++) {
					  case 0:
						  target->name = line.mid(j + 1).trimmed();
						  break;
					  case 1:
						  // TODO check type with existing one!
						  target->groupName = line.mid(j + 1).trimmed();
						  break;
					  case 2:
						  // TODO check type with existing one!
						  target->type = line.mid(j + 1).trimmed();
						  break;
					  default:
						  TargetField * field = new TargetField ();
						  field->name = line.mid (0, j).trimmed();
						  field->value = line.mid(j + 1).trimmed();
						  field->order = 10 * (i - 2);
						  field->encrypted = true;
						  if (field->name.contains("url", Qt::CaseInsensitive)) {
							  field->type = TYPE_URL;
						  }
						  else
						  if (field->name.contains("password", Qt::CaseInsensitive)) {
							  field->type = TYPE_PASSWORD;
						  }
						  else
						  if (field->name.contains("pin", Qt::CaseInsensitive)) {
							  field->type = TYPE_PASSWORD;
						  }
						  else
						  if (field->name.contains("phone", Qt::CaseInsensitive)) {
							  field->type = TYPE_PHONE_NUMBER;
						  }
						  else
						  if (field->name.contains("number", Qt::CaseInsensitive)) {
							  field->type = TYPE_INTEGER;
						  }
						  else
						  if (field->name.contains("date", Qt::CaseInsensitive)) {
							  field->type = TYPE_DATE;
						  }
						  else
						  if (field->name.contains("note", Qt::CaseInsensitive)) {
							  field->type = TYPE_TEXT;
						  }
						  else
							  field->type = TYPE_STRING;
						  target->fields.append(field);
					  }

					  //qDebug () << line << " | " << line.mid(j + 1) << " IS " << line.mid (0, j);
		    	  }
		    	  else {
		    		  if (target != NULL && target->fields.size() > 0) {
		    			  target->fields.last()->value.append("\n").append (line);
		    			  target->fields.last()->type = TYPE_TEXT;
		    		  }
		    	  }
		      }
		      else {
		    	  if (target != NULL) {
		    		  this->__insertTarget(target);
		    	  }
		    	  target = NULL;
		    	  i = 0;
		      }

		      QApplication::instance()->processEvents();

		      //qDebug () << line;
		    }

			 if (target != NULL) {
				  this->__insertTarget(target);
			 }
		    // Close the file
		    file.close();

		    showInfo (true);
		  }
	}
	this->setAttribute(Qt::WA_Maemo5ShowProgressIndicator, false);
}

void eWallet::newTarget() {
	//qDebug()<<"new ";

	if (detailWindowEdit.isNull()) {
		detailWindowEdit = new DetailWindow(NULL, currentGroup, false, true, this, this);
		//detailWindowEdit->setAttribute(Qt::WA_Maemo5StackedWindow);
        detailWindowEdit->setAttribute(Qt::WA_DeleteOnClose);
        connect(detailWindowEdit, SIGNAL(destroyed(QObject*)),
                this, SLOT(windowDestroyed(QObject*)));
        detailWindowEdit->show();
	}
}

void eWallet::contextMenuEvent (QContextMenuEvent * event) {
	//qDebug () << "Should be show " << this->childAt(event->globalPos());

	if (isShowGroups == 1) {

	}
	else {
		if (fnListWidget->currentRow() >= 0) {
		Target * target = list.at(fnListWidget->currentRow());

			QMenu menu(this);
			menu.addAction("View", this, SLOT(_viewcTarget()));
			menu.addAction("Edit", this, SLOT(_editcTarget()));
			menu.addAction("New like this", this, SLOT(_newLikeTarget()));
			menu.addAction("Delete", this, SLOT(_deletecTarget()));
			menu.exec(event->globalPos());
		}
	}
}

void eWallet::exportData() {
	QString path(QDesktopServices::storageLocation(QDesktopServices::HomeLocation));
	QString s = QFileDialog::getSaveFileName(
	                this,
	                "Choose export file",
	                path,
	                "Text (*.txt)");

	this->setAttribute(Qt::WA_Maemo5ShowProgressIndicator, true);
	if (!s.isNull () && !s.isEmpty ()) {
		  QFile file(s);

		  if ( file.open(QIODevice::Text | QIODevice::WriteOnly) ) {
		    // file opened successfully
		    QTextStream t(&file);        // use a text stream

			for (int i = 0; i < list.size (); i++) {
				Target * target = list[i];

				t << "Name: " << target->name << "\n";
				t << "Group Name: " << target->groupName << "\n";
				t << "Type: " << target->type << "\n";

				dbManager->getFields(target);

				TargetField * field;
				foreach(field, target->fields) {
					t << field->name << ": " << field->value << "\n";
				}

				t << "\n\n";

				target->freeFieldList();

				QApplication::instance()->processEvents();

			}

		    // Close the file
		    file.close();
		  }
	}
	this->setAttribute(Qt::WA_Maemo5ShowProgressIndicator, false);
}

void eWallet::_newLikeTarget() {
	if (fnListWidget->currentRow() >= 0) {
		Target * target = list.at(fnListWidget->currentRow());

		dbManager->getFields(target);

		if (detailWindowEdit.isNull()) {
			detailWindowEdit = new DetailWindow(target, currentGroup, true, true, this, this);
			//detailWindowEdit->setAttribute(Qt::WA_Maemo5StackedWindow);
	        detailWindowEdit->setAttribute(Qt::WA_DeleteOnClose);
	        connect(detailWindowEdit, SIGNAL(destroyed(QObject*)),
	                this, SLOT(windowDestroyed(QObject*)));
	        detailWindowEdit->show();
		}
	}
}

void eWallet::_editcTarget() {
	if (fnListWidget->currentRow() >= 0) {
		Target * target = list.at(fnListWidget->currentRow());
		editTarget(target);
	}
}
void eWallet::_deletecTarget() {
	if (fnListWidget->currentRow() >= 0) {
		Target * target = list.at(fnListWidget->currentRow());
		deleteTarget(target);
	}
}
void eWallet::_viewcTarget() {
	if (fnListWidget->currentRow() >= 0) {
		Target * target = list.at(fnListWidget->currentRow());
		viewTarget(target);
	}
}

void eWallet::closeEvent(QCloseEvent *event){
	//qDebug () << "close Event";
	event->accept();
}

void eWallet::askPassword () {
	times = 0;
	
	isAskPassword = true;
	createMenu();

	if (loginDialogDlg.isNull()) {
		loginDialogDlg = new LoginDialog(!::dbManager->hasPassword (), this);

		// TODO should I remove all included widgets??
		setCentralWidget(loginDialogDlg);
		//show ();
		setFocus ();
		focusNextChild();

//		centralWidget = NULL;
//		vboxlayout = NULL;
//		fnListWidget = NULL;
//		inputWidget = NULL;
//		cancelSearch = NULL;
//		searchField = NULL;
//		hideSearch = NULL;
	}
}

void eWallet::about() {
	QMessageBox::about(this, "About qtWallet", TEXT_ABOUT);
}
